## Position Of Phantom Source, by Jean-Luc Ohl
## Calculation of LOC, compared levels of direct sound and reverberation levels, an idea and a script from David Griesinger
## Thanks to Denis Sbragion, author of DRC from which I used parts of scripts
## This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
## This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.


cd C:\Users\jlo\Desktop\pops\files\octave\;
wavfileL1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\ir-L.wav';
wavfilenameL1 = "ir-L.wav";
wavfilepathL1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\';
wavfileR1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\ir-R.wav';
wavfilenameR1 = "ir-R.wav";
wavfilepathR1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\';
wavfileL2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\ir-L.wav';
wavfilenameL2 = "ir-L.wav";
wavfilepathL2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\';
wavfileR2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\ir-R.wav';
wavfilenameR2 = "ir-R.wav";
wavfilepathR2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\';
fdevice = '-S1200,400';
binaural = 0;





##############################################################################	
	fext = ".png";
	margins.L1   = 0.04;
	margins.R1  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 1.5;
	
	# Colormap, line colors and line width for 3d surface plots
	EDLw = 0.25;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	ULColor = [0.85, 0.85, 0.85];
	LLColor = [0.85, 0.85, 0.85];	
	
	# Enable contour display when set to > 0
	surcntenable = 0;
	mapcntenable = 0;
	
##############################################################################	
	
	[irL1,fs,bps] = wavread([wavfileL1]);
	[irR1,fs,bps] = wavread([wavfileR1]);	
	[irL2,fs,bps] = wavread([wavfileL2]);
	[irR2,fs,bps] = wavread([wavfileR2]);	
	
##############################################################################	

	[irm1,ic1] = max(abs(irL1));
	[irm2,ic2] = max(abs(irR1));
	ic = min(ic1,ic2);
	ln = min(length(irL1),length(irR1));
	irL1 = irL1(ic:ln);
	irR1 = irR1(ic:ln);
	[irm1,ic1] = max(abs(irL2));
	[irm2,ic2] = max(abs(irR2));
	ic = min(ic1,ic2);
	ln = min(length(irL2),length(irR2));
	irL2 = irL2(ic:ln);
	irR2 = irR2(ic:ln);
	
upper_scale = 20;  % 20dB range for firings

% proposed box length D
D = round(100*fs/1000);  % try 100ms
early_time = round(5*fs/1000);
wb = [2*700/fs 2*4000/fs];
[b a] = butter(2,wb);

ir_L1 = filter(b,a,irL1);
ir_R1 = filter(b,a,irR1);
ir_L2 = filter(b,a,irL2);
ir_R2 = filter(b,a,irR2);

datamax = min(max(ir_L1),max(ir_R1));
for index1 = 1:0.2*fs
	if abs(ir_L1(index1))+abs(ir_R1(index1)) > datamax/20
		break
	end
end
datamax = min(max(ir_L2),max(ir_R2));
for index1 = 1:0.2*fs
	if abs(ir_L2(index1))+abs(ir_R2(index1)) > datamax/20
		break
	end
end
ir_L1(1:index1-20) = [];
ir_R1(1:index1-20) = [];
ir_L2(1:index1-20) = [];
ir_R2(1:index1-20) = [];

% ir_L1 is an ipselateral binaural impulse response, %truncated to start at zero and filtered to 700-4000Hz.
% early_time is 5ms in samples, D is 100ms in samples.

SL1 = upper_scale-10*log10(sum(ir_L1.^2));
SR1 = upper_scale-10*log10(sum(ir_R1.^2));
SL2 = upper_scale-10*log10(sum(ir_L2.^2));
SR2 = upper_scale-10*log10(sum(ir_R2.^2));

earlyL1 = 10*log10(sum(ir_L1(1:early_time).^2));
earlyR1 = 10*log10(sum(ir_R1(1:early_time).^2));
earlyL2 = 10*log10(sum(ir_L2(1:early_time).^2));
earlyR2 = 10*log10(sum(ir_R2(1:early_time).^2));

% first integral is a cumsum representing the build up in energy when the IR is excited by a steady tone:

ln = length(ir_L1);
log_rvbL1 = 10*log10(cumsum(ir_L1(early_time:ln).^2));
log_rvbR1 = 10*log10(cumsum(ir_R1(early_time:ln).^2));
ln = length(ir_L2);
log_rvbL2 = 10*log10(cumsum(ir_L2(early_time:ln).^2));
log_rvbR2 = 10*log10(cumsum(ir_R2(early_time:ln).^2));

% look at positive values of S+log_rvb  only

for ix = 1:ln-early_time
	if SL1+log_rvbL1(ix) < 0
		log_rvbL1(ix) = -SL1;
	end
end

for ix = 1:ln-early_time
	if SR1+log_rvbR1(ix) < 0
		log_rvbR1(ix) = -SR1;
	end
end

for ix = 1:ln-early_time
	if SL2+log_rvbL2(ix) < 0
		log_rvbL2(ix) = -SL2;
	end
end

for ix = 1:ln-early_time
	if SR2+log_rvbR2(ix) < 0
		log_rvbR2(ix) = -SR2;
	end
end

LOCL1 = (earlyL1+SL1) - (1/D)*sum(SL1+log_rvbL1(1:D-early_time))
LOCR1 = (earlyR1+SR1) - (1/D)*sum(SR1+log_rvbR1(1:D-early_time))
LOCL2 = (earlyL2+SL2) - (1/D)*sum(SL1+log_rvbL2(1:D-early_time))
LOCR2 = (earlyR2+SR2) - (1/D)*sum(SR1+log_rvbR2(1:D-early_time))

%************************* graph box ********************

ir_L1_rvb = ir_L1;
ir_L1_rvb(1:early_time) = datamax/100000; %zeros(size(1:early_time);
ir_R1_rvb = ir_R1;
ir_R1_rvb(1:early_time) = datamax/100000; %zeros(size(1:early_time);
ir_L2_rvb = ir_L2;
ir_L2_rvb(1:early_time) = datamax/100000; %zeros(size(1:early_time);
ir_R2_rvb = ir_R2;
ir_R2_rvb(1:early_time) = datamax/100000; %zeros(size(1:early_time);

if (binaural == 1)
L1_power = sqrt((sum(ir_L1.^2)+sum(ir_R1.^2))/2);
R1_power = L1_power;
L2_power = sqrt((sum(ir_L2.^2)+sum(ir_R2.^2))/2);
R2_power = L2_power;
else
L1_power = sqrt(sum(ir_L1.^2));
R1_power = sqrt(sum(ir_R1.^2));
L2_power = sqrt(sum(ir_L2.^2));
R2_power = sqrt(sum(ir_R2.^2));
endif

build_up_totalL1 = sqrt(cumsum(ir_L1_rvb/L1_power).^2);
build_up_totalR1 = sqrt(cumsum(ir_R1_rvb/R1_power).^2);
build_up_totalL2 = sqrt(cumsum(ir_L2_rvb/L2_power).^2);
build_up_totalR2 = sqrt(cumsum(ir_R2_rvb/R2_power).^2);

direct_level_totalL1 = sqrt(sum(ir_L1(1:early_time)/L1_power).^2);
direct_level_totalR1 = sqrt(sum(ir_R1(1:early_time)/R1_power).^2);
direct_level_totalL2 = sqrt(sum(ir_L2(1:early_time)/L2_power).^2);
direct_level_totalR2 = sqrt(sum(ir_R2(1:early_time)/R2_power).^2);

ln = length(build_up_totalL1);
assymptote_totalL1 = 20*log10(build_up_totalL1(ln));
assymptote_totalR1 = 20*log10(build_up_totalR1(ln));
ln = length(build_up_totalL2);
assymptote_totalL2 = 20*log10(build_up_totalL2(ln));
assymptote_totalR2 = 20*log10(build_up_totalR2(ln));

direct_reverb_totalL1 = 20*log10(direct_level_totalL1)- assymptote_totalL1;
direct_reverb_totalR1 = 20*log10(direct_level_totalR1)- assymptote_totalR1;
log_build_up_totalL1 = 20*log10(build_up_totalL1)- assymptote_totalL1;
log_build_up_totalR1 = 20*log10(build_up_totalR1)- assymptote_totalR1;
direct_reverb_totalL2 = 20*log10(direct_level_totalL2)- assymptote_totalL2;
direct_reverb_totalR2 = 20*log10(direct_level_totalR2)- assymptote_totalR2;
log_build_up_totalL2 = 20*log10(build_up_totalL2)- assymptote_totalL2;
log_build_up_totalR2 = 20*log10(build_up_totalR2)- assymptote_totalR2;

n = round(fs*122/1000);
n2 = round(fs*200/1000);
n3 = D;

direct_level_total_plotL1(1:n) = direct_reverb_totalL1;
direct_level_total_plotL1(n+1:n2) = -80;
direct_level_total_plotR1(1:n) = direct_reverb_totalR1;
direct_level_total_plotR1(n+1:n2) = -80;
direct_level_total_plotL2(1:n) = direct_reverb_totalL2;
direct_level_total_plotL2(n+1:n2) = -80;
direct_level_total_plotR2(1:n) = direct_reverb_totalR2;
direct_level_total_plotR2(n+1:n2) = -80;

window_plot(1:n3) = 0;
window_plot(n3+1:n2) = -80;
zero_line_plot(1:n2) = -upper_scale;

build_up_L1 = sqrt(cumsum((ir_L1_rvb/L1_power).^2));
direct_level_L1 = sqrt(sum((ir_L1(1:early_time)/L1_power).^2));
ln = length(build_up_L1);
assymptote_reverb_L1 = 20*log10(build_up_L1(ln));
assymptote_total_L1 = 20*log10(L1_power);
direct_reverb_L1 = 20*log10(direct_level_L1)- assymptote_reverb_L1;
log_build_up_L1 = 20*log10(build_up_L1);  %- assymptote_total_L1;
direct_level_L1_plot(1:n) = 20*log10(direct_level_L1);
direct_level_L1_plot(n+1:n2) = -80;

build_up_R1 = sqrt(cumsum((ir_R1_rvb/R1_power).^2));
direct_level_R1 = sqrt(sum((ir_R1(1:early_time)/R1_power).^2));
ln = length(build_up_R1);
assymptote_reverb_R1 = 20*log10(build_up_R1(ln));
assymptote_total_R1 = 20*log10(R1_power);
direct_reverb_R1 = 20*log10(direct_level_R1)- assymptote_reverb_R1;
log_build_up_R1 = 20*log10(build_up_R1);  %- assymptote_total_R1;
direct_level_R1_plot(1:n) = 20*log10(direct_level_R1);
direct_level_R1_plot(n+1:n2) = -80;

build_up_L2 = sqrt(cumsum((ir_L2_rvb/L2_power).^2));
direct_level_L2 = sqrt(sum((ir_L2(1:early_time)/L2_power).^2));
ln = length(build_up_L2);
assymptote_reverb_L2 = 20*log10(build_up_L2(ln));
assymptote_total_L2 = 20*log10(L2_power);
direct_reverb_L2 = 20*log10(direct_level_L2)- assymptote_reverb_L2;
log_build_up_L2 = 20*log10(build_up_L2);  %- assymptote_total_L2;
direct_level_L2_plot(1:n) = 20*log10(direct_level_L2);
direct_level_L2_plot(n+1:n2) = -80;

build_up_R2 = sqrt(cumsum((ir_R2_rvb/R2_power).^2));
direct_level_R2 = sqrt(sum((ir_R2(1:early_time)/R2_power).^2));
ln = length(build_up_R2);
assymptote_reverb_R2 = 20*log10(build_up_R2(ln));
assymptote_total_R2 = 20*log10(R2_power);
direct_reverb_R2 = 20*log10(direct_level_R2)- assymptote_reverb_R2;
log_build_up_R2 = 20*log10(build_up_R2);  %- assymptote_total_R2;
direct_level_R2_plot(1:n) = 20*log10(direct_level_R2);
direct_level_R2_plot(n+1:n2) = -80;

window_plot(1:n3) = 0;
window_plot(n3+1:n2) = -80;

zero_line_plot(1:n2) = -upper_scale;

	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");	
	
	subplot(1,4,1);
	hold("on");
	ixg= [1:n2];
	plot(1000*(ixg)/fs, direct_level_L1_plot(ixg)+20, ["3;" "direct sound" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, log_build_up_L1(ixg)+20, ["1;" "reflections buildup" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, window_plot(ixg)+20, ["2;" "final level" ";"],"LineWidth",DLW);
	axis([0 100 0 20]);
	grid("on");
	ylabel("rate of nerve firings - sound energy");	
	title([wavfilenameL1 " Griesinger LOC=" num2str(LOCL1,2) "dB"]);	
	hold("off");
	
	subplot(1,4,2);
	hold("on");
	ixg= [1:n2];
	plot(1000*(ixg)/fs, direct_level_R1_plot(ixg)+20, ["3;" "direct sound" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, log_build_up_R1(ixg)+20, ["1;" "reflections buildup" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, window_plot(ixg)+20, ["2;" "final level" ";"],"LineWidth",DLW);
	axis([0 100 0 20]);
	grid("on");
	title([wavfilenameR1 " Griesinger LOC=" num2str(LOCR1,2) "dB"]);	
	hold("off");

	subplot(1,4,3);
	hold("on");
	ixg= [1:n2];
	plot(1000*(ixg)/fs, direct_level_L2_plot(ixg)+20, ["3;" "direct sound" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, log_build_up_L2(ixg)+20, ["1;" "reflections buildup" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, window_plot(ixg)+20, ["2;" "final level" ";"],"LineWidth",DLW);
	axis([0 100 0 20]);
	grid("on");
	title([wavfilenameL1 " Griesinger LOC=" num2str(LOCL2,2) "dB"]);	
	hold("off");
	
	subplot(1,4,4);
	hold("on");
	ixg= [1:n2];
	plot(1000*(ixg)/fs, direct_level_R2_plot(ixg)+20, ["3;" "direct sound" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, log_build_up_R2(ixg)+20, ["1;" "reflections buildup" ";"],"LineWidth",DLW);
	plot(1000*(ixg)/fs, window_plot(ixg)+20, ["2;" "final level" ";"],"LineWidth",DLW);
	axis([0 100 0 20]);
	grid("on");
	title([wavfilenameR1 " Griesinger LOC=" num2str(LOCR2,2) "dB"]);	
	hold("off");
	
	# Print to the output file
	print([ wavfilepathL1 wavfilenameL1 "-loc" fext ],fdevice);
	
	# Report the stage
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);