## Position Of Phantom Source, by Jean-Luc Ohl
## Calculation of IACC and amplitude difference for frequency dependant source position
## Thanks to Denis Sbragion, author of DRC from which I used parts of scripts
## This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
## This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 
cd C:\Users\jlo\Desktop\pops\files\octave\;
wavfileL ='C:\Users\jlo\Desktop\pops\measurements\test14\ir-L.wav';
wavfileR ='C:\Users\jlo\Desktop\pops\measurements\test14\ir-R.wav';
wavfilepath = 'C:\Users\jlo\Desktop\pops\measurements\test14\';
fdevice = '-S1200,220';





##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.04;
	margins.bottom = 0.11; 
	set(0,"defaultaxesfontsize",9)
	
	# Set the default line width
	DLW = 2;	
##############################################################################	
	
	[irL,fs,bps] = wavread([wavfileL]);
	[irR,fs,bps] = wavread([wavfileR]);
	
##############################################################################	

	[irmL,icL] = max(abs(irL));	
	[irmR,icR] = max(abs(irR));		

	# Normalize to +1
	irL = sign(max(real(irL(:)))/max(real(-irL(:)))-1)*irL/irmL;	
	irR = sign(max(real(irR(:)))/max(real(-irR(:)))-1)*irR/irmR;	
	
	# Report the impulse centers
	disp(sprintf("irL impulse center: %d, max: %f",icL, irmL));
	disp(sprintf("irR impulse center: %d, max: %f",icR, irmR));
	
	# Resampling factor
	rf = 40;
	
	# Resampling filter length, cutoff frequency and attenuation
	rfl = 16383;
	rcf = 0.95;
	rat = 160;
	
	# Upsample from about -10 to +50 ms
	irp = 1*fs/100;
	ira = 5*fs/100;
	
	# Creates the oversampled impulse responses
	irLos = rf * iupsample(irL([icL-irp:icL+ira]),rf,rfl,rcf,rat);
	irRos = rf * iupsample(irR([icR-irp:icR+ira]),rf,rfl,rcf,rat);
	
	#ir peak and ETC to 0
	rmsL = max(irLos);
	irLos = irLos(:)/rmsL;
	rmsR = max(irRos);
	irRos = irRos(:)/rmsR;
	
	# Report the stage
	disp("Time response, full range...");
	fflush(stdout);
	
	# Open a new plot
	newplot();
	clf();	
	figure(1,"visible","off");
	
	# Plot the oversampled impulse responses L
	subplot(1,2,1);
	plot(1000 * ((([0:length(irLos)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),irLos,["3;" ";"],"LineWidth",DLW);
	axis([-10, 50, -1, 1]);
	grid("on");
	title("Impulse response L");

	# Plot the oversampled impulse responses R
	subplot(1,2,2);
	plot(1000 * ((([0:length(irRos)-1])/(rf*fs))-((irp/fs) + ((rfl + 1)/(2*rf*fs)))),irRos,["3;" ";"],"LineWidth",DLW);
	axis([-10, 50, -1, 1]);
	grid("on");
	title("Impulse response R");
	
	# Save the axis range
	g1ax = axis();
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(3) = min(g1ax(3));
	gax(4) = max(g1ax(4));
	
	# Computes the uniform axis range
	gax = g1ax;
	gax(1) = -10;
	gax(2) = 50;
	gax(3) = -1;
	gax(4) = 1;

	# Print to the output file
	print([ wavfilepath "ir" fext ],fdevice);
	disp("Completed, wait for GNUPlot to complete before opening output files.");
	fflush(stdout);