## Position Of Phantom Source, by Jean-Luc Ohl
## Calculation of IACC and amplitude difference for frequency dependant source position
## Thanks to Denis Sbragion, author of DRC from which I used parts of scripts
## This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
## This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 
cd C:\Users\jlo\Desktop\pops\files\octave\;
wavfileL1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\ir-L.wav';
wavfilenameL1 = "ir-L.wav";
wavfilepathL1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\';
wavfileR1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\ir-R.wav';
wavfilenameR1 = "ir-R.wav";
wavfilepathR1 = 'C:\Users\jlo\Desktop\pops\measurements\meyer8\';
wavfileL2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\ir-L.wav';
wavfilenameL2 = "ir-L.wav";
wavfilepathL2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\';
wavfileR2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\ir-R.wav';
wavfilenameR2 = "ir-R.wav";
wavfilepathR2 = 'C:\Users\jlo\Desktop\pops\measurements\meyer10\';
fdevice = '-S1200,400';
factordelay = 0.03;
factorampl = 0.5;
  
 
 
 
##############################################################################	
	fext = ".png";
	margins.left   = 0.04;
	margins.right  = 0.01;
	margins.top    = 0.01;
	margins.bottom = 0.01; 
	set(0,"defaultaxesfontsize",9)
	# Set the default line width
	DLW = 1.5;
	EDCMap = hsv2rgb([linspace(0.60,0.00,256)', 1.0 * ones(256,1), 0.65 * ones(256,1)]);	
	
##############################################################################	
	# Report the stage
	disp("POPS works...");
	fflush(stdout);
	
	[wavL1,fs,bps] = wavread([wavfileL1]);
	wavL1 = [zeros(16384,1); wavL1(:); zeros(65536,1)];	
	[wavR1,fs,bps] = wavread([wavfileR1]);
	wavR1 = [zeros(16384,1); wavR1(:); zeros(65536,1)];
	[wavL2,fs,bps] = wavread([wavfileL2]);
	wavL2 = [zeros(16384,1); wavL2(:); zeros(65536,1)];		
	[wavR2,fs,bps] = wavread([wavfileR2]);	
	wavR2 = [zeros(16384,1); wavR2(:); zeros(65536,1)];	

	# find max peak
	[irm1,icL1] = max(abs(wavL1));	
	[irm2,icR1] = max(abs(wavR1));	
	[irmL2,icL2] = max(abs(wavL2));	
	[irmR2,icR2] = max(abs(wavR2));	
	
	# find delay offset in d
	disp("interaural delays estimated in degrees");
	fflush(stdout);	
	icd1 = (icR1 - icL1)*1000/(fs*factordelay)
	icd2 = (icR2 - icL2)*1000/(fs*factordelay)
	
	# Extract the windowed impulse responses
	irwvL1 = wavL1([icL1-4096:icL1+8191]);
	irwvR1 = wavR1([icR1-4096:icR1+8191]);
	irwvL2 = wavL2([icL2-4096:icL2+8191]);
	irwvR2 = wavR2([icR2-4096:icR2+8191]);	

	# Performs the frequency dependant windowing
	irwL1 = irslprefilt(irwvL1,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwR1 = irslprefilt(irwvR1,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwL2 = irslprefilt(irwvL2,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	irwR2 = irslprefilt(irwvR2,4097,20/fs,4800,20000/fs,6,1,4096,1,10,0);
	
	irssL1 = ssev(irwL1,fs,0.16,1);
	irssR1 = ssev(irwR1,fs,0.16,1);	
	irssL2 = ssev(irwL2,fs,0.16,1);
	irssR2 = ssev(irwR2,fs,0.16,1);	
	
	deltaampl1 = 20*log10(irssL1) - 20*log10(irssR1);
	deltaampl2 = 20*log10(irssL2) - 20*log10(irssR2);

	deltaampl1= reshape(deltaampl1, columns(deltaampl1), 1);
	deltaampl1 = resample(deltaampl1, fs/2, rows(deltaampl1));
	deltaampl2= reshape(deltaampl2, columns(deltaampl2), 1);
	deltaampl2 = resample(deltaampl2, fs/2, rows(deltaampl2));
		
################################## 
	factorscale = 150;
	centerline = 1453;

	# 23 Center frequencies
	cf = [125 160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500 16000 20000];
	# Computes the 22 frequency bounds
	fb = (cf(1:(end-1)) .* cf(2:(end))) .^ 0.5;
	# Remove the unused center frequencies, this leaves 20 center frequencies
	cf = cf(2:(end-1));

	# prepare IACC matrix
	iacc1 = [160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500; 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
	iacc2 = [160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500; 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
	
	for cb = 1:20 
		# Computes the current filter
		bf = bandpassfir(16384,2 * cf(cb) / fs,2 * cf(cb + 1) / fs) .* chebwin(16384,60)';
			
		# Computes the band ir
		birfL1 = fftconv(bf,irwL1);
		birfR1 = fftconv(bf,irwR1);
		birfL2 = fftconv(bf,irwL2);
		birfR2 = fftconv(bf,irwR2);	
		
		# Computes amplitude shift in d
		birsa1 = (20*log10(rms(birfL1)) - 20*log10(rms(birfR1)))/factorampl;
		birsa2 = (20*log10(rms(birfL2)) - 20*log10(rms(birfR2)))/factorampl;
		
		# Computes interaural crosscorrelation, shift with delay offset and amplitude				
		birx1(cb,:) = xcorr(abs(birfL1), abs(birfR1),'coeff');
		[birxm,birxlag] = max(birx1(cb,:));
		iacc1(2,cb) = icd1+birxlag-23230;
		birx2(cb,:) = xcorr(abs(birfL2), abs(birfR2),'coeff');
		[birxm,birxlag] = max(birx2(cb,:));
		iacc2(2,cb) = icd2+birxlag-23230;
		
		# Computes max xcorr delay in d		
		birshift1 = icd1 + birsa1 + (birxlag-columns(birx1)/2)*1000/(fs*factordelay);
		# limit shift to +-29	
		birshift1 = min(29*factordelay/0.01, abs(birshift1))*sign(birshift1);
		birx1(cb,:) = shift(birx1(cb,:), round(birshift1*factorscale/(7.5)));	
	
		birx2(cb,:) = xcorr(abs(birfL2), abs(birfR2),'coeff');			
		[birxm,birxlag] = max(birx2(cb,:));
		birshift2 = icd2 + birsa2 + (birxlag-columns(birx2)/2)*1000/(fs*factordelay); 		
		birshift2 = min(29*factordelay/0.01, abs(birshift2))*sign(birshift2);
		birx2(cb,:) = shift(birx2(cb,:), round(birshift2*factorscale/(7.5)));	
	endfor
	 
		birt1	= transpose(birx1);
		birt2	= transpose(birx2);

		# Resample to reduce data	
	for n= 1:20
		birr1(:,n) = resample(birt1(:,n),1,16);
		birm1(:,n) = birr1(:,n)./max(birr1(:,n));
		birr2(:,n) = resample(birt2(:,n),1,16);
		birm2(:,n) = birr2(:,n)./max(birr2(:,n));
	endfor

	ce = [160 200 250 315 400 500 630 800 1000 1250 1600 2000 2500 3150 4000 5000 6300 8000 10000 12500];
	for cb = 1:20
		iacc1(3,cb) = deltaampl1(ce(cb));	
		iacc2(3,cb) = deltaampl2(ce(cb));
	endfor		
	
#############################################################################	
	disp("Plot...");
	fflush(stdout);
	
	# Open a new plot
	newplot();
	clf();
	figure(1,"visible","off");
	
	# Enable holding the plot
	subplot(2,2,1);
	hold("on");	
	
	subplot(2,2,1);
	ixg= [1:columns(iacc1)];
	semilogx(iacc1(1,ixg)/1000, iacc1(3,ixg)/factorampl, ["3;" "ILD amplitude L-R" ";"],"LineWidth",DLW);
	semilogx(iacc1(1,ixg)/1000, min(abs(iacc1(2,:)),29) .* sign(iacc1(2,:)), ["1;" "ITD iacc L-R" ";"],"LineWidth",DLW);	
	semilogx(iacc1(1,ixg)/1000, min(abs(iacc1(2,ixg)+iacc1(3,ixg)/factorampl)/2,29) .* sign(iacc1(2,ixg)+iacc1(3,ixg)/factorampl), ["2;" "ITD + ILD" ";"],"LineWidth",DLW);	

	axis([0.2, 12, -30, 30]);
	grid("on");
	set(gca, 'xticklabel','400|1.2k|4k|12k','yticklabel','R 30|20|10|0|10|20|L 30');	
	title(["POPS Position Of Phantom Source " sprintf("ITD=%.3fms/, ILD=%.2fdB/",factordelay, factorampl) ""]);
	
	# Disable holding the plot and set graph parameters
	subplot(2,2,1);
	hold("off");
	
	subplot(2,2,2);
	imagesc(birm1,[0.5, 1]); 
	grid("on");		
	set(gca(),"ydir","normal");
	axis([2, 20, (centerline-factorscale*(factordelay/0.04)), centerline+(factorscale*(factordelay/0.04))], "label[x]");
	safetics("y",(centerline-factorscale*(factordelay/0.04)):(50*(factordelay/0.04)):centerline+(factorscale*(factordelay/0.04)));
	set(gca, 'xticklabel','','yticklabel','R 30|20|10|0|10|20|L 30');
	colormap(EDCMap);		
	title([wavfilenameL1 " - " wavfilenameR1]);

	# Enable holding the plot
	subplot(2,2,3);
	hold("on");	
	
	subplot(2,2,3);
	ixg= [1:columns(iacc2)];
	semilogx(iacc2(1,ixg)/1000, iacc2(3,ixg)/factorampl, ["3;" "ILD amplitude L-R" ";"],"LineWidth",DLW);
	semilogx(iacc2(1,ixg)/1000, min(abs(iacc2(2,:)),29) .* sign(iacc2(2,:)), ["1;" "ITD iacc L-R" ";"],"LineWidth",DLW);	
	semilogx(iacc2(1,ixg)/1000,  min(abs(iacc2(2,ixg)+iacc2(3,ixg)/factorampl)/2,29) .* sign(iacc2(2,ixg)+iacc2(3,ixg)/factorampl), ["2;" "ITD + ILD" ";"],"LineWidth",DLW);	

	axis([0.2, 12, -30, 30]);
	grid("on");
	set(gca, 'xticklabel','400|1.2k|4k|12k','yticklabel','R 30|20|10|0|10|20|L 30');	

	# Disable holding the plot and set graph parameters
	subplot(2,2,3);
	hold("off");
	
	subplot(2,2,4);
	imagesc(birm2,[0.5, 1]); 
	grid("on");		
	set(gca(),"ydir","normal");
	axis([2, 20, (centerline-factorscale*(factordelay/0.04)), centerline+(factorscale*(factordelay/0.04))], "label[x]");
	safetics("y",(centerline-factorscale*(factordelay/0.04)):(50*(factordelay/0.04)):centerline+(factorscale*(factordelay/0.04)));
	set(gca, 'xticklabel','400|1.2k|4k|12k','yticklabel','R 30|20|10|0|10|20|L 30');
	colormap(EDCMap);		
	title([wavfilenameL2 " - " wavfilenameR2]);

	# Print to the output file
	print([wavfilepathL1 wavfilenameL1 "-" wavfilenameL2 fext ],fdevice);

	# Report
	disp("Completed.");
	fflush(stdout);
	